{% extends "consensus_base/base_dashboard_alt.html" %}
{% load i18n %}
{% load sekizai_tags %}
{% load consensus %}
{% block title %}Consensus - Polls{% endblock %}

{% block main-h1 %}
{% trans 'Poll:' %} {{ poll.title }}
- [<a class="btn-sm btn-link" target="_blank" href="{% url 'consensus_base:poll_formatted' poll.slug %}">{% trans 'export' %}</a>]
{% if poll|ispolladmin:request.user.username %}
- [<a class="btn-sm btn-link" href="{% url 'consensus_base:poll_edit' poll.slug %}">{% trans 'edit' %}</a>]
- [<a class="btn-sm btn-link" href="{% url 'consensus_base:poll_settings' poll.slug %}">{% trans 'settings' %}</a>]
{% endif %}
{% endblock main-h1 %}

{% block main %}

<!-- Begin web poll section -->
<div class="card">
    <div class="card-header" id="overall-status-description">
    Description: {{ poll.description }}
    </div>
    <div class="card-body">
        <div class="" id="overall-status-pending-votes"><b>Pending votes:</b> -</div>
        <div class="" id="overall-status-participants-with-pending-votes">-</div>
        <br/>
        <div class="">Questions highlighted on <b style="color:green">green</b> are already submitted</div>
        <div class="">Questions highlighted on <b style="color:orange">orange</b> are waiting for your answer</div>
        <div class="">Questions not highlighted on any color are optional and they don't require your explicit vote</div>
        <div class="">You can <b>click</b> on the questions to see the available choices</div>
    </div>
</div>

<ul id="poll" class="list-group"></ul>
<!-- End web poll section -->

                 
{% addtoblock "js" %}
    var username = "{{ request.user }}";
    var json_answer = "{% url 'consensus_base:json_answer' %}";
    var json_comment = "{% url 'consensus_base:json_comment' %}";
    var json_poll_status = "{% url 'consensus_base:json_poll_status' poll.uuid.hex %}";
    var json_poll_changes = "{% url 'consensus_base:json_poll_changes' poll.uuid.hex %}";
    var last_change_uuid;

    function render_poll_overall_status() {
        console.log("Refreshed overall status");
        console.log(poll_status);
        is_locked = "";
        if (poll_status['overall']['locked']) {
            is_locked = '<i>(poll is locked at this moment)</i>';
        }
        $("#main-h1>b").text("Polls: " + poll_status['overall']['title']);
        $("#overall-status-description").html("<b>Description:</b> " + poll_status['overall']['description']);
        $("#overall-status-pending-votes").html("<b>Pending votes "
            + is_locked
            + ":</b> "
            + poll_status['overall']['num_of_participants_pending']
            + " (of "
            + poll_status['overall']['num_of_participants']
            + " participants) over "
            + poll_status['overall']['num_of_mandatory_questions_total']
            + " mandatory questions ( +"
            + (poll_status['overall']['num_of_questions_total'] - poll_status['overall']['num_of_mandatory_questions_total'])
            + " optional questions)"
        );
        $("#overall-status-participants-with-pending-votes").text('(' + poll_status['overall']['list_of_participants_pending'].join(", ") + ')');

    $(":input").each(function(){
        $(this).prop('disabled', poll_status['overall']['locked']);
    });

    }


    function get_preferred_choice(question) {
        return 1
    }

    function render_choices_status(question) {
        console.log("Refreshed choices status");
        console.log(question);

        for (var c in question.choices) {
            participants = question.choices[c].list_of_participants
            if (participants.length == 0) {
                participants = "-"
            }
            else {
                participants = participants.join(", ")
            }
            num_of_answers = question.choices[c].num_of_answers
            $("#question-choice-status-" + question.uuid + "-" + c).text(
                'Votes (' + num_of_answers 
                + '): '
                + participants
            );
        }
    }


    function render_question_status(question) {
        console.log("Refreshed question status");
        console.log(question);
        optional = '';
        if (question.mandatory == false) {
            optional = " (optional)"
        }

        preferred_choice = get_preferred_choice(question);
        preferred = "";
        if (question.hasOwnProperty('choices' && question.choices.length > 0) ) {
            you_voted = ' (Preferred choice is "' + question.choices[Object.keys(question.user_answer)[preferred_choice]].text + '")'
        }

        you_voted = " (You didn't vote yet)";
        if (question.hasOwnProperty('user_answer') ) {
            you_voted = ' (You voted for choice "' + question.choices[Object.keys(question.user_answer)[0]].text +'")';
        }

        $("#question-status-number-" + question.uuid).html('<b>Submitted votes:'
            + '</b> ' + question.num_of_answers  + '/' + poll_status.overall.num_of_participants 
            + you_voted
            + optional
            + preferred
        );

        pending_participants = poll_status.overall.list_of_participants_pending.filter( function( el ) {
            return question.list_of_participants.indexOf( el ) < 0;
        } );
        $("#question-status-title-"+ question.uuid).html('<b>Q:</b> ' + question.text);
        if (question.mandatory == true) {
            $("#question-status-list-" + question.uuid).html('<b>Pending votes ('
                + (poll_status.overall.num_of_participants - question.num_of_answers) + '): </b>'
                + pending_participants.join(", ")
            );
            if (! question.hasOwnProperty('user_answer')) {
                $("#question-"+ question.uuid).removeClass('question-optional');
                $("#question-"+ question.uuid).removeClass('question-answered');
                $("#question-"+ question.uuid).addClass('question-mandatory');
            }
            if (question.hasOwnProperty('user_answer')) {
                $("#question-"+ question.uuid).removeClass('question-optional');
                $("#question-"+ question.uuid).removeClass('question-mandatory');
                $("#question-"+ question.uuid).addClass('question-answered');
            }
        }
        else {
            $("#question-status-list-" + question.uuid).html('');
            if (question.hasOwnProperty('user_answer')) {
                $("#question-"+ question.uuid).removeClass('question-optional');
                $("#question-"+ question.uuid).removeClass('question-mandatory');
                $("#question-"+ question.uuid).addClass('question-answered');
            }
            else {
                $("#question-"+ question.uuid).removeClass('question-answered');
                $("#question-"+ question.uuid).removeClass('question-mandatory');
                $("#question-"+ question.uuid).addClass('question-optional');
            }
        }
    }

    function delete_comment(e) {
        var comment_uuid = e.target.id.replace('delete-comment-button-','');
        console.log("Comment: " + comment_uuid);
        $.ajax({
            type:"POST",
            url: json_comment,
            data: {
                action: 'delete',
                comment: comment_uuid,
            },
            dataType: 'json',
            success: function (data) {
                console.log("Comment deleted: " + comment_uuid);
                console.log(data);
                if (data.return == 0) {
                    delete_question_comment(comment_uuid);
                    clean_action_message();
                    show_save_message()
                }
                else {
                    show_error_message(data.message)
                }
            }
        });
    }


    function select_choice(e) {
        var choice_uuid = e.target.id.replace('question-choices-group-','').split('-');
        console.log("Choice selected: " + choice_uuid);
        $.ajax({
            type:"POST",
            url: json_answer,
            data: {
                action: 'update',
                question: choice_uuid[0],
                choice: choice_uuid[1],
                value: true,
            },
            dataType: 'json',
            success: function (data) {
                console.log("Selected choice: " + choice_uuid);
                console.log(data);
                if (data.return == 0) {
                    render_question_status(data.value);
                    render_choices_status(data.value);
                    clean_action_message();
                    show_save_message()
                }
                else {
                    show_error_message(data.message)
                }
            }
        });
    }


    function submit_comment(e) {
        var question_uuid;
        if (typeof e == "string") {
            e = e.split('-');
            question_uuid = e[e.length-1]
        }
        else {
            question_uuid = e.target.id.replace('question-comment-button-','')
        }
        var comment = $('#question-comment-input-' + question_uuid).val();
        $('#question-comment-input-' + question_uuid).val('');
        console.log("Question: " + question_uuid);
        console.log("Question: " + comment);
        $.ajax({
            type:"POST",
            url: json_comment,
            data: {
                action: 'create',
                question: question_uuid,
                value: comment,
            },
            dataType: 'json',
            success: function (data) {
                console.log("Question commented: " + question_uuid);
                if (data.return == 0) {
                    add_question_comment_in_list("#question-comments-" + question_uuid, data['value']);
                    clean_action_message();
                    show_save_message()
                }
                else {
                    show_error_message(data.message)
                }
            }
        });
    }


    function render_question_choices (question) {
        var question_uuid = question.uuid;
        $( "#question-inner-choices-" + question_uuid ).html(
            '  <div class="" id="question-status-list-' + question.uuid + '">'
            + '-'
            + '</div>'
            + '<ul class="questions" id="question-choices-' + question_uuid + '"></ul>'
        );
        for (var c in question.choices) {
            if (question.choices.hasOwnProperty(c)) {
                var choice_group = 'question-choices-group-' + question_uuid;
                var choice_id = 'question-choices-group-' + question_uuid + '-' + c;
                var choice_status_id = 'question-choice-status-' + question_uuid + '-' + c;
                $( "#question-choices-" + question_uuid).append(
                    '<li class="list-group-item">'
                    + '<input class="question-choice" name="' + choice_group + '" type="radio" id="' + choice_id + '">'
                    + '<label for="' + choice_id + '">'
                    + question.choices[c].text
                    + '</label>'
                    + '<div class="" id="' + choice_status_id + '">'
                    + ' Votes (-): -'
                    + '</div>'
                    + '</li>');
                $( "#" + choice_id ).click(select_choice);
            }
        }
        for (var a in question.user_answer) {
            var choice_id = 'question-choices-group-' + question_uuid + '-' + a;
            if (question.user_answer.hasOwnProperty(a)) {
                $('#' + choice_id).prop('checked', true);
            }
        }
        render_choices_status(question);
    }


    function delete_question_comment(comment_uuid){
        $("#comment-" + comment_uuid).remove();
    }


    function add_question_comment_in_list(list_id, comment) {
        if($('#comment-' + comment.uuid).length == 0) {
            var c_mtime = new Date(comment.mtime * 1000);
            var res = '<li class="" style="list-style-type:none" id="comment-' + comment.uuid  + '">'
                + '['
                + c_mtime.toISOString().replace('T', ' ').split('.')[0]
                + '] ['
                + comment.username
                + ']: '
                + comment.comment;
            if (comment.username == username) {
                delete_link = ' - <button type="button" class=" btn-xs btn-outline-secondary" id="delete-comment-button-' + comment.uuid  + '" >delete</button>';
                res = res + delete_link;
            }
            res = res + '</li>';
            $( list_id ).prepend(res);
            $( "#delete-comment-button-" + comment.uuid).click(delete_comment);
        }
    }


    function render_question_comment(comment) {
        var question_uuid = comment.question_uuid;
        add_question_comment_in_list("#question-comments-" + question_uuid, comment);
    }


    function render_question_comments (question) {
        var question_uuid = question.uuid;
        $( "#question-inner-comments-" + question_uuid ).html( 'Comments:' );
        input_comment = '<div class="ml-1 form-group row">'
        + '<input class="question-comment form-control input-sm col-12 col-md-10 col-xl-11" name="' + question_uuid + '" type="text" id="question-comment-input-' + question_uuid + '">'
        + '<button id="question-comment-button-' + question_uuid + '"type="button" class="btn-xs btn-primary col-12 col-md-2 col-xl-1">Comment</button>'
        + '</div>';
        $( "#question-inner-comments-" + question_uuid ).append(input_comment);
        $( "#question-comment-input-" + question_uuid ).keypress(function(e) {
            if(e.which == 13) {
                submit_comment('#question-comment-input-' + question_uuid)
            }
        });
        $( "#question-comment-button-" + question_uuid ).click(submit_comment);

        $( "#question-inner-comments-" + question_uuid ).append( '<ul class="comments" id="question-comments-' + question_uuid + '"></ul>' );
        for (var c in question.comments) {
            if (question.comments.hasOwnProperty(c)) {
                add_question_comment_in_list("#question-comments-" + question_uuid, question.comments[c]);
            }
        }
    }

    function render_poll(data){
        var i;
        for (i = 0; i < data.questions.length; i++) {
            render_question(data.questions[i])
        }
    }

    function render_question(question){
        if (question.hide)
        {
            console.log("Question set hide: " + question.uuid );
            if($("#question-" + question.uuid).length != 0) {
                $('#question-' + question.uuid).fadeOut( 5000, function() {
                    $('#question-' + question.uuid).remove()
                });
            }
        }
        else {
            if($("#question-" + question.uuid).length == 0) {
                $( "#poll" ).append(
                    '<li id="question-' + question.uuid + '" class="list-group-item">'
                    + '<div data-toggle="collapse" data-target="#question-inner-' + question.uuid + '">'
                    + '  <div id="question-status-title-' + question.uuid + '">'
                    + '-'
                    + '  </div>'
                    + '  <div class="" id="question-status-number-' + question.uuid + '">'
                    + '-'
                    + '  </div>'
                    + '</div>'
                    + '<div class="collapse" id="question-inner-' + question.uuid + '">'
                    + '<div id="question-inner-choices-' + question.uuid + '"/>'
                    + '<div id="question-inner-comments-' + question.uuid + '"/>'
                    + '</div>'
                    + '</li>'
                );
            }
            if($("#question-" + question.uuid).length == 1) {
                render_question_choices(question);
                render_question_comments(question);
                render_question_status(question);
            }
        }
    }


    function load_json_poll_status() {
        $.ajax({
            url: json_poll_status,
            success: function (data) {
                console.log("Loaded poll status");
                console.log(data);
                poll_status = data;
                render_poll(poll_status);
                render_poll_overall_status()
            }
        });
    }


    function changes() {
        $.ajax({
            url: json_poll_changes + '?last_change_uuid=' + last_change_uuid, 
            success: function(data) {
                try {
                    if (data['return'] == 0) {
                        if (data['value'].hasOwnProperty('last_change_uuid')) {
                            last_change_uuid = data['value']['last_change_uuid']
                            if (data['value'].hasOwnProperty('changes')) {
                                for (var c in data.value.changes) {
                                    poll_status['overall'] = data.value.changes[c].change.overall;
                                    value = data.value.changes[c].change.value;
                                    if (data.value.changes[c].change.type == 'question_updated') {
                                        render_question(value);
                                    }
                                    if (data.value.changes[c].change.type == 'question_deleted') {
                                        $('#question-' + value.uuid).fadeOut( 5000, function() {
                                            $('#question-' + value.uuid).remove()
                                        });
                                    }
                                    if (data.value.changes[c].change.type == 'question_created') {
                                        render_question(value)
                                    }
                                    if (data.value.changes[c].change.type == 'choice_updated') {
                                        render_question_choices(value);
                                        render_question_status(value);
                                    }
                                    if (data.value.changes[c].change.type == 'question_answered') {
                                        render_question_choices(value);
                                        render_question_status(value);
                                    }
                                    if (data.value.changes[c].change.type == 'comment_created') {
                                        render_question_comment(value);
                                    }
                                    if (data.value.changes[c].change.type == 'comment_deleted') {
                                        $('#comment-' + value.uuid).fadeOut( 5000, function() {
                                            $('#question-' + value.uuid).remove()
                                        });
                                    }

                                }
                                render_poll_overall_status();
                                show_save_message()
                            }
                        }
                        else {
                            if (data['value'].hasOwnProperty('previous_last_change_uuid')) {
                                last_change_uuid = data['value']['previous_last_change_uuid']
                            }
                        }
                    }
                }
                catch(err) {
                    console.log("Error during the changes polling");
                    console.log(err)
                }
            },
            complete: function() {
                // Schedule the next request when the current one is complete
                setTimeout(changes, 5000);
            }
    })}

 
    $(document).ready(function(){
        load_json_poll_status();
        changes();
    })

{% endaddtoblock %}
{% endblock main %}
